#include "rope.h"
#include "smalloc.h"

/* Fix this not to use ropes, I think */

char *
decode_i3(char *str)
{
	static rope_t	*r = NULL;
	char			*cp;
	char			*sp;

	/* We really frig this rope by reference */
	if (!r) r = rope_new();

	rope_set(r, str);
	cp = rope_get(r);
	sp = cp;

	while (*cp) {
		switch(*cp) {
			case '\r':
				*sp++ = '\n';
				break;
			case '\\':
				switch(*++cp) {
					case '\\':
						*sp++ = '\\';
						break;
					case '"':
						*sp++ = '"';
						break;
					default:
						fprintf(stderr, "Stray '\' in string '%s'\n", str);
						*sp++ = '\\';
						*sp++ = *cp;
				}
				break;
			default:
				*sp++ = *cp;
		}
		cp++;
	}
	*sp = 0;

	return rope_get(r);
}

char *
encode_i3(char *str)
{
	static rope_t	*r = NULL;
	char			*cp;
	char			*sp;

	/* We frig this one too */
	if (!r) r = rope_new();

	rope_set(r, str);
	rope_add(r, str);	/* Make the rope twice as long */
	/* We assume that the rope remains allocated to twice the length
	 * of the initial string, so that we can screw about with the
	 * memory allocated therein */

	cp = str;
	sp = rope_get(r);
	while (*cp) {
		switch(*cp) {
			case '\\':
				*sp++ = '\\';
				*sp++ = '\\';
				break;
			case '"':
				*sp++ = '\\';
				*sp++ = '"';
				break;
			case '\n':
				*sp++ = '\r';
				break;
			default:
				*sp++ = *cp;
		}
		cp++;
	}
	*sp = 0;

	return rope_get(r);
}
