#ifndef __BUFFER_H__
#define __BUFFER_H__

#include "object.h"

typedef char byte;

typedef
struct _buffer_t {
	object_t	 parent;
	void		*data;
	int			 size;	/* Allocated size, excluding terminating NULL */
	int			 length;/* Used length */
} buffer_t;

typedef
struct _buffer_class_t {
	object_class_t	 parent;
} buffer_class_t;

#define ROPE_LENGTH	(32)

buffer_t	*buffer_new();
int			 buffer_type(void);
void		 buffer_delete(buffer_t *buffer);
byte		*buffer_get(buffer_t *buffer);
int			 buffer_length(buffer_t *buffer);
buffer_t	*buffer_add(buffer_t *b, byte *data, int len);
void		 buffer_set(buffer_t *b, byte *data, int len);

#endif
