#ifndef __CONTAINER_H__
#define __CONTAINER_H__

#include "library.h"
#include "object.h"

typedef struct _container_t container_t;

typedef void (*handler_t)(container_t *, object_t *);

struct _container_t {
	object_t		 parent;
	handler_t		 add;
	handler_t		 remove;
	/* Children? */
};

typedef
struct _container_class_t {
	object_class_t	 parent;
} container_class_t;

void	 container_add(container_t *c, object_t *o);
void	 container_remove(container_t *c, object_t *o);
void	 container_delete(container_t *c);
void	 container_init(container_t *c);
void	 container_class_init(container_class_t *c);
int		 container_type(void);

#endif
