#ifndef __OBJECT_H__
#define __OBJECT_H__

#include <sys/types.h>
#include "library.h"

#define OBJ(x) ((object_t *)(x))

typedef
struct _object_class_t {
	int			 type;
	delete_t	 delete;
	hashfunc_t	 hash;
	compare_t	 equals;
	stringify_t	 string;
} object_class_t;

typedef
struct _object_t {
	object_class_t	*class;
	int				 refcount;
} object_t;

/* uint defined in <sys/types.h> */

int		 object_type(void);
void	 object_init(object_t *o);
void	 object_class_init(object_class_t *c);
void	 object_delete(object_t *o);
void	 object_ref(object_t *o);
void	 object_unref(object_t *o);
object_class_t *
		 object_class(object_t *o);
int		 object_typenum(object_t *o);
char	*object_typeof(object_t *o);
int		 object_equals(object_t *o, object_t *p);
uint	 object_hash(object_t *o);
char	*object_stringify(object_t *o);

#endif
