#ifndef __ROPE_H__
#define __ROPE_H__

#include "object.h"

typedef
struct _rope_t {
	object_t	 parent;
	char		*chars;
	int			 size;	/* Allocated size, excluding terminating NULL */
	int			 length;/* Used length */
} rope_t;

typedef
struct _rope_class_t {
	object_class_t	 parent;
} rope_class_t;

#define ROPE_LENGTH	(32)

#define ropep(r) (object_typenum(OBJ(r)) == rope_type())

rope_t	*rope_new(void);
int		 rope_type(void);
void	 rope_delete(rope_t *rope);
char	*rope_get(rope_t *rope);
int		 rope_length(rope_t *rope);
rope_t	*rope_add(rope_t *targ, char *src);
void	 rope_set(rope_t *targ, char *str);
rope_t	*rope_concat(rope_t *targ, rope_t *src);
char	*rope_substr(rope_t *rope, int start, int end);
rope_t	*rope_new_Pc(char *str);

#endif
