#ifndef __TYPE_H__
#define __TYPE_H__

#include "object.h"

typedef void (*init_t)(object_t *);
typedef void (*cinit_t)(object_class_t *);

typedef
struct _type_t {
	char			*name;
	int				 size;
	int				 csize;
	init_t			 init;
	cinit_t			 cinit;
	object_class_t	*class;
} type_t;

int			 type_unique(type_t *typeinfo);
object_class_t *
			 type_class(int type);
char		*type_name(int type);
object_t	*type_new(int type);
void		 type_delete(object_t *o);
int			 type_refs(object_t *o);
void		 type_ref(object_t *o);
void		 type_unref(object_t *o);

#endif
