#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "smalloc.h"

void *
smalloc(size_t size)
{
	void	*ret = malloc(size);
	if (!ret) {
		fprintf(stderr, "smalloc: Could not malloc %d bytes\n", size);
		exit(0);
	}
	return ret;
}

void *
srealloc(void *ptr, size_t size)
{
	void	*ret = realloc(ptr, size);
	if (!ret) {
		fprintf(stderr, "smalloc: Could not realloc %d bytes\n", size);
		exit(0);
	}
	return ret;
}

char *
sstrdup(char *str)
{
	char	*out;
	out = strdup(str);
	if (!out) {
		fprintf(stderr, "smalloc: Could not duplicate %s\n", str);
		exit(0);
	}
	return out;
}
