#include <sys/types.h>
#include <dirent.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "library.h"
#include "vector.h"
#include "smalloc.h"

vector_t *
dirvec_new(char *path)
{
	DIR				*dir;
	struct dirent	*dirent;
	vector_t		*v;

	dir = opendir(path);
	if (!dir) {
		fprintf(stderr, "Could not opendir() '%s': %s",
						path, strerror(errno));
		return NULL;
	}

	v = vector_new(free, 0);

	while ((dirent = readdir(dir)) != NULL) {
		if (!dirent->d_reclen) continue;    /* Blank filenames */
		if (*dirent->d_name == '.') continue;	/* Dotfile */
		vector_push_back(v, sstrdup(dirent->d_name));
	}

	closedir(dir);

	return v;
}
