#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "library.h"
#include "vector.h"
#include "smalloc.h"
#include "type.h"
#include "rope.h"

vector_t *	/* vector_t */
explode(rope_t *r, char *delim)	/* LPC rexplode() */
{
	static char	*input;
	static int	 len;
	vector_t	*vec;
	char		*source;
	char		*basep;
	char		*endp;

	source = rope_get(r);

	if (!input) {
		len = strlen(source) + 10;
		input = (char *)smalloc(len * sizeof(char));
	}
	else if (len <= strlen(source)) {
		len = strlen(source) + 10;
		input = (char *)srealloc(input, len * sizeof(char));
	}

	strcpy(input, source);

	vec = (vector_t *)type_new(vector_type());

	basep = input;
	endp = strpbrk(input, delim);
	while (endp) {
		*endp = '\0';
		vector_push_back(vec, (object_t *)rope_new_Pc(basep));
		basep = ++endp;
		endp = strpbrk(basep, delim);
	}
	vector_push_back(vec, (object_t *)rope_new_Pc(basep));

	return vec;
}

rope_t *
implode(vector_t *v, char *delim)
{
	object_t	*o;
	rope_t		*rope;
	int			 rtype;
	int			 len;
	int			 i;

	rtype = rope_type();
	rope = (rope_t *)type_new(rtype);
	
	len = vector_length(v);

	for (i = 0; i < len; i++) {
		if (i) rope_add(rope, delim);
		o = OBJ(vector_data(v, i));
		if (!o)
			DPRINTF((stderr, "NULL item in implode vector"));
		if (object_typenum(o) != rtype)
			DPRINTF((stderr, "%s in implode vector", object_typeof(o)));
		rope_add(rope, rope_get((rope_t *)o));
	}

	return rope;
}

#if 0
char *
lower_case(char *str)
{
	char	*cp;
	cp = str;
	while (*cp) {
		*cp = tolower(*cp);
		cp++;
	}
	return str;
}
#endif
