#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <netdb.h>

#include "config.h"
#include "network.h"

char	*n_hostname = CONFIG_ROUTER_NAME;
int		 n_port = CONFIG_ROUTER_PORT;

void network_set_connection (char *host, int port)
	{ n_hostname = host; n_port = port; }

int
network_make_connection (void)
{
	struct sockaddr_in	 s_addr;
	struct hostent		*hostp;
	u_long				 ip_addr;
	int					 sock;

	printf("Attempting connect to %s on port %d\n",
					n_hostname, n_port);

	sock = socket(AF_INET, SOCK_STREAM, 0);
	if (sock < 0) {
		perror("Cannot create socket");
		return -1;
	}

	memset(&s_addr, 0, sizeof(s_addr));
	s_addr.sin_family = AF_INET;
	if ((ip_addr = inet_addr(n_hostname)) != INADDR_NONE) {
		memcpy(&s_addr.sin_addr, &ip_addr, sizeof(ip_addr));
	} else {
		hostp = gethostbyname(n_hostname);
		if (!hostp) {
			perror("Cannot resolve hostname");
			exit(-1);
			return -1;
		}
		memcpy(&s_addr.sin_addr, hostp->h_addr, hostp->h_length);
	}
	s_addr.sin_port = htons(n_port);
	if (connect(sock, (struct sockaddr *)&s_addr, sizeof(s_addr)) < 0) {
		perror("Cannot connect to remote host");
		exit(-1);
		return -1;
	}
	return sock;
}

void network_close_connection (int sock)
	{ close(sock); }
