#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "value.h"
#include "lists.h"

int
value_size (long v_value)
{
	int i = 1;
	if (v_value < 0) i++;
	while ((v_value /= 10)) i++;
	return i;
}

value *
value_new (int v_type)
{
	value	*v	= (value *)malloc(sizeof(value));
	v->v_type	= v_type;
	v->v_value	= 0;
	v->v_string	= NULL;
	v->k		= NULL;
	v->d		= NULL;
	v->v_plength	= 0;
/* Be careful with these */
	if (v_type == MM_STRING) v->v_plength = V_LEN_NUL;
	if (v_type == MM_VALUE) v->v_plength = V_LEN_NUL;
	return v;
}

value *
value_new_data (int v_type, void *v_data)
{
	value	*v = value_new(v_type);
	switch (v_type) {
		case MM_STRING:
			if (v_data) {
				v->v_string = strdup((char *)(v_data));
				v->v_plength = strlen((char *)(v_data)) + V_LEN_QUOTES;
			}
			break;
		case MM_VALUE:
			v->v_value = (long)(v_data);
			v->v_plength = value_size((long)(v_data));
			break;
		case MM_ARRAY:
		case MM_MAPPING:
			printf("ERROR: Shouldn't create new_data with MAPPING\n");
			v->v_array = v_data;	/* This is NEVER used */
			break;
		default:
			fprintf(stderr, "packet_node_new called with %d\n", v_type);
	}
	return v;
}

void
value_destroy (value *v)
{
	if (!v) return;
	switch (v->v_type) {
		case MM_ARRAY:
			// list_destroy((listentry *)(v->v_array));
			printf("ERROR: cannot destroy array\n");
			break;
		case MM_STRING:
			free(v->v_string);
			break;
		case MM_MAPPING:
			printf("ERROR: cannot destroy mapping\n");
			break;
		case MM_VALUE:
			break;
		default:
			break;
	}
	free(v);
}
