#ifndef __SHANDLER_H__
#define __SHANDLER_H__

#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

#include "library.h"
#include "buffer.h"

#define MAX_WRITE		(1023)	/* Default attempt to write */
#define MAX_WRITEBUF	(65535)	/* Max write buffer on frozen fd */
#define MAX_READ		(4095)
#define MAX_READBUF		(65535)

/* Extract from my param.h with added warnings */
#ifndef MAX
#define MAX(_a,_b)      ((_a)<(_b)?(_b):(_a))
#else
#warning MAX already defined by OS
#endif
#ifndef MIN
#define MIN(_a,_b)      ((_a)<(_b)?(_a):(_b))
#else
#warning MIN already defined by OS
#endif

typedef struct _shandler_t shandler_t;

typedef void (*readcall_t)(shandler_t *, int, buffer_t *);

typedef
struct _scallback_t {
	int					 fd;
	readcall_t			 read;
	buffer_t			*readbuf;
	buffer_t			*writebuf;
	struct _scallback_t	*next;
} scallback_t;

struct _shandler_t {
	fd_set		 rfd;
	fd_set		 wfd;
	fd_set		 xfd;
	int			 maxfd;
	scallback_t	*calls;
};

shandler_t	*shandler_new(void);
void		 shandler_delete(shandler_t *s);
void		 shandler_remove_fd(shandler_t *s, int fd);
bool		 shandler_add_fd(shandler_t *s, int fd, readcall_t read);
bool		 shandler_write_to(shandler_t *s, int fd,
							byte *data, int len);
int			 shandler_run(shandler_t *s);

#endif
