#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <netdb.h>

#include "network.h"

int
network_connection_new(char *host, int port)
{
	struct sockaddr_in	 s_addr;
	struct hostent		*hostp;
	u_long				 ip_addr;
	int					 sock;

	printf("Attempting connect to %s on port %d\n",
					host, port);

	sock = socket(AF_INET, SOCK_STREAM, 0);
	if (sock < 0) {
		perror("Cannot create socket");
		return -1;
	}

	memset(&s_addr, 0, sizeof(s_addr));
	s_addr.sin_family = AF_INET;
	if ((ip_addr = inet_addr(host)) != INADDR_NONE) {
		memcpy(&s_addr.sin_addr, &ip_addr, sizeof(ip_addr));
	} else {
		hostp = gethostbyname(host);
		if (!hostp) {
			perror("Cannot resolve hostname");
			exit(-1);
			return -1;
		}
		memcpy(&s_addr.sin_addr, hostp->h_addr, hostp->h_length);
	}
	s_addr.sin_port = htons(port);
	if (connect(sock, (struct sockaddr *)&s_addr, sizeof(s_addr)) < 0) {
		perror("Cannot connect to remote host");
		exit(-1);
		return -1;
	}
	return sock;
}

void
network_connection_delete(int sock)
{
	close(sock);
}
