#include <string.h>

#include "library.h"
#include "object.h"
#include "hash.h"
#include "smalloc.h"

#include "shandler.h"
#include "users.h"

static hash_t	*users = NULL;

static user_t *
user_new(char *name, shandler_t *s, int fd)
{
	user_t	*u;
	u = (user_t *)smalloc(sizeof(user_t));
	u->name = rope_new_Pc(name);	/* For equalities */
	u->shandler = s;
	u->fd = fd;
	object_ref(OBJ(u->name));
	return u;
}

static void
user_delete(user_t *u)
{
	/* Remove from shandler before? Or check here too? */
	object_unref(OBJ(u->name));
	sfree(u);
}

bool
users_boot(void)
{
	if (!users) {
		users = hash_new();
	}

	return TRUE;
}

bool
users_init(void)
{
	/* Add a commandline/stdin user? */
	return TRUE;
}
