#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include "library.h"
#include "hash.h"
#include "rope.h"
#include "utils.h"
#include "type.h"
#include "smalloc.h"

#define H_ADD(x, y) hash_add(hash, x, sstrdup(y))
#define H_GET(x) ((char *)(hash_get(hash, x)))
#define STR "||b|bakph|Park Hyatt Baku|Park Hyatt Baku|Baku,Azerbaijan|Baku|International Park|Hotel|ok|||||Sumgait Caspian Sea|"

void
test_smalloc(void)
{
	void	*x;

	x = smalloc(50);
	x = sstrdup("foo");
	printf("Got dup'd string %s\n", x);
}

void
test_hash (void)
{
	hash_t	*hash;

	hash = (hash_t *)type_new(hash_type());
	// hash_set_destructor(hash, sfree);

	H_ADD("foo", "bar");
	printf("foo = %s  (should be 'bar')\n", H_GET("foo"));
	H_ADD("abc", "abc");
	printf("abc = %s  (should be 'abc')\n", H_GET("abc"));
	printf("foo = %s  (should be 'bar')\n", H_GET("foo"));
	H_ADD("foo", "qux");
	printf("foo = %s  (should be 'qux')\n", H_GET("foo"));
}

void
test_explode(void)
{
	vector_t	*v;
	char		*s;
	char		*t;

	v = explode(STR, "|");
	s = implode(v, "|");
	t = implode(v, "|");

	printf("Line is %s\n", STR);
	printf("Str  is %s\n", s);
	printf("Str  is %s\n", t);
}

void
test_vector(void)
{
	vector_t	*v;
	// v = vector_new(NULL, 0);
	v = (vector_t *)type_new(vector_type());
	vector_push_back(v, "0");
	printf("Push back;\tVector is %s\n", implode(v, ", "));
	vector_push_back(v, "1");
	printf("Push back;\tVector is %s\n", implode(v, ", "));
	vector_insert(v, "2", 1);
	printf("Insert 1;\tVector is %s\n", implode(v, ", "));
	vector_push_front(v, "3");
	printf("Push front;\tVector is %s\n", implode(v, ", "));
	vector_insert(v, "4", 2);
	printf("Insert 2;\tVector is %s\n", implode(v, ", "));
	vector_pop(v, 3);
	printf("Pop 3;   \tVector is %s\n", implode(v, ", "));
	vector_pop_front(v);
	printf("Pop front;\tVector is %s\n", implode(v, ", "));
	vector_pop_back(v);
	printf("Pop back;\tVector is %s\n", implode(v, ", "));
	vector_remove(v, 0);
	printf("Remove 0;\tVector is %s\n", implode(v, ", "));
}

int
main (void)
{
	test_smalloc();
	test_hash();
	test_explode();
	test_vector();

	return 0;
}
